<template>
  <template-page ref="pageRef" :get-list="getList" :table-attributes="tableAttributes" :table-events="tableEvents"
    :options-evens-group="optionsEvensGroup" :moreParameters="moreParameters" :column-parsing="columnParsing"
    :operation="operation" :exportList="exportList">
    <div slot="moreSearch">
      <el-radio-group v-model="type" size="mini" @change="changeType">
        <el-radio-button :label="''">全部</el-radio-button>
        <el-radio-button :label="true">开启</el-radio-button>
        <el-radio-button :label="false">禁用</el-radio-button>
      </el-radio-group>
      <br><br>
    </div>
    <el-dialog title="" width="600px" custom-class="diy-dialog" append-to-body :modal="true" :visible.sync="formDialog"
      :show-close="true" :close-on-click-modal="false" :modal-append-to-body="false" :before-close="formCancel">
      <zj-form-container ref="formRef" :form-data="formData" :styleSwitch="false">
        <zj-form-module :title="formDialogTitles[formDialogType]" label-width="120px" :showPackUp="false"
          :form-data="formData" :form-items="formItems">
        </zj-form-module>
      </zj-form-container>
      <div slot="footer" class="dialog-footer">
        <el-button size="mini" @click="formCancel">取 消</el-button>
        <el-button size="mini" @click="formConfirm" type="primary">确 定</el-button>
      </div>
    </el-dialog>
  </template-page>
</template>

<script>
import TemplatePage from '@/components/template/template-page-1.vue'
import import_mixin from '@/components/template/import_mixin.js'
import { required, mobileRequired, mobile } from '@/components/template/rules_verify.js'
import { chargingStandardList3, chargingStandardList3PageExport, chargingStandardImport, getMainList, getMainDetail, saveMain, deleteMain, getBrandList } from "@/api/miniapp";
import { getClassifyList } from '@/api/goods'
import { downloadFiles } from '@/utils/util'
export default {
  components: { TemplatePage },
  mixins: [import_mixin],
  data() {
    return {
      type: "",
      // 事件组合
      optionsEvensGroup: [
        [
          [
            {
              name: '下载导入模板',
              click: this.handleDownload
            }
          ],
          [
            {
              name: '导入模板',
              render: () => {
                return this.importButton(chargingStandardImport, '导入模板')
              }
            }
          ],
        ],
        [
          [
            {
              name: '添加',
              click: this.addData
            }
          ],
        ]
      ],
      // 表格属性
      tableAttributes: {
        // 启用勾选列
        selectColumn: false
      },
      // 表格事件
      tableEvents: {
        'selection-change': this.selectionChange
      },
      // 勾选选中行
      recordSelected: [],
      /** 表单变量 */
      formDialogType: 0,
      formDialogTitles: ["新增", "编辑", "查看"],
      formDialog: false,
      formData: {
        brandId: "",
        oneCategoryId: "",
        twoCategoryId: "",
        content1: "",
        content2: "",
        status: true,
      },
      brandList: [], // 品牌列表
      mainList: [], // 一级分类列表
      smallList: [], // 二级分类列表
    }
  },
  computed: {
    // 更多参数
    moreParameters() {
      return []
    },
    formItems() {
      return [
        {
          md: 24,
          isShow: true,
          name: 'el-select',
          options: this.brandList,
          attributes: { filterable: true, placeholder: '请选择', disabled: this.formDialogType == 2, },
          formItemAttributes: {
            label: '服务品牌',
            prop: 'brandId',
            rules: [...required]
          }
        },
        {
          md: 24,
          isShow: true,
          name: 'el-select',
          options: this.mainList,
          attributes: { filterable: true, placeholder: '请选择', disabled: this.formDialogType == 2, },
          formItemAttributes: {
            label: '一级分类',
            prop: 'oneCategoryId',
            rules: [...required]
          },
          events: {
            change: async val => {
              this.smallList = []
              this.formData.twoCategoryId = ""
              if (val) {
                this.smallList = this.mainList.find(item => {
                  return item.value == val;
                })?.data?.children?.map(item => ({
                  label: item.name,
                  value: item.categoryId,
                  data: item
                })) || [];
              }
            }
          }
        },
        {
          md: 24,
          isShow: true,
          name: 'el-select',
          options: this.smallList,
          attributes: { filterable: true, placeholder: '请选择', disabled: this.formDialogType == 2, },
          formItemAttributes: {
            label: '二级分类',
            prop: 'twoCategoryId',
            rules: [...required]
          }
        }, {
          md: 24,
          isShow: true,
          name: 'el-input',
          attributes: { placeholder: '请输入', disabled: this.formDialogType == 2, },
          formItemAttributes: {
            label: '故障内容',
            prop: 'content1',
            rules: [...required]
          }
        }, {
          md: 24,
          isShow: true,
          name: 'el-input',
          attributes: { placeholder: '请输入', type: "textarea", disabled: this.formDialogType == 2, },
          formItemAttributes: {
            label: '故障排除指引',
            prop: 'content2',
            rules: [...required]
          }
        },
        {
          md: 24,
          isShow: true,
          name: 'el-radio',
          options: [{ label: "开启", value: true }, { label: "禁用", value: false }],
          attributes: { filterable: true, placeholder: '请选择', disabled: this.formDialogType == 2 },
          formItemAttributes: {
            label: '状态',
            prop: 'status',
            rules: [...required]
          }
        },

      ]
    }
  },
  methods: {
    // 切换状态
    changeType(val) {
      this.$refs.pageRef.refreshList()
    },
    // 列表请求函数
    getList(p) {
      try {
        var pam = JSON.parse(JSON.stringify(p))
        if (this.type !== '') {
          pam.params.push({ "param": "a.status", "compare": "=", "value": this.type })
        }
        return chargingStandardList3(pam)
      } catch (error) {
        console.log(error)
      } finally {

      }
    },
    // 列表导出函数
    exportList: chargingStandardList3PageExport,
    // 表格列解析渲染数据更改
    columnParsing(item, defaultData) {
      return defaultData
    },
    // 监听勾选变化
    selectionChange(data) {
      this.recordSelected = data
    },
    // 表格操作列
    operation(h, { row, index, column }) {
      return (
        <div class='operation-btns'>
          <el-button type="text" onClick={() => {
            getMainDetail({ id: row.id }).then(res => {
              Object.assign(this.formData, res.data)
              this.formDialogType = 2
              this.openForm()
            })
          }}>查看</el-button>
          <el-button type="text" onClick={() => {
            getMainDetail({ id: row.id }).then(res => {
              Object.assign(this.formData, res.data)
              this.formDialogType = 1
              this.openForm()
            })
          }}>编辑</el-button>
          <el-popconfirm
            title="确定删除吗？"
            onConfirm={() => {
              deleteMain({ id: row.id }).then(res => {
                this.$message({
                  type: 'success',
                  message: `删除成功!`,
                })
                this.$refs.pageRef.refreshList()
              })
            }}
          >
            <el-button type="text" slot="reference">删除</el-button>
          </el-popconfirm>
        </div>
      )
    },
    addData() {
      this.formDialogType = 0
      this.openForm()
    },
    openForm() {
      Promise.all([
        getBrandList(),
        getClassifyList({
          type: 2,
          name: '',
        })
      ]).then(([res2, res3]) => {
        this.brandList = res2.data.map(item => ({
          label: item.brandName,
          value: item.id,
          data: item
        }));
        this.mainList = res3.data.map(item => ({
          label: item.name,
          value: item.categoryId,
          data: item
        }));
        if (this.formData.oneCategoryId) {
          this.smallList = this.mainList.find(item => {
            return item.value == this.formData.oneCategoryId;
          })?.data?.children?.map(item => ({
            label: item.name,
            value: item.categoryId,
            data: item
          })) || [];
        }
        this.formDialog = true;
      })
    },
    formCancel() {
      this.$refs.formRef.$refs.inlineForm.clearValidate()
      this.$data.formData = this.$options.data().formData
      this.formDialog = false
    },
    formConfirm() {
      this.$refs.formRef.validate((valid, invalidFields, errLabels) => {
        if (valid) {
          saveMain({...this.formData, type:2}).then(res => {
            this.$message({
              type: 'success',
              message: this.formDialogTitles[this.formDialogType] + `成功!`,
            })
            this.formCancel()
            this.$refs.pageRef.refreshList()
          })
        }
      })
    },
    // 下载导入模版
    handleDownload() {
      downloadFiles('charging/standard/download');
    },
  }
}
</script>

<style lang="scss" scoped></style>
